## cvm 0.90

=== Makefile ===
# Don't edit Makefile!  Use conf-* for configuration.
#
# Generated by spac see http://untroubled.org/spac/

SHELL=/bin/sh

DEFAULT: all

all: libraries programs docs

clean: TARGETS
	rm -f `cat TARGETS`

clean-spac: clean AUTOFILES
	rm -f `cat AUTOFILES`

client_domain.lo client_domain.o: libcompile client_domain.c v1client.h facts.h errors.h
	./libcompile client_domain.c

client_setenv.lo client_setenv.o: libcompile client_setenv.c v1client.h facts.h errors.h
	./libcompile client_setenv.c

client_setugid.lo client_setugid.o: libcompile client_setugid.c v1client.h facts.h errors.h
	./libcompile client_setugid.c

client_xfer_command.lo client_xfer_command.o: libcompile client_xfer_command.c v1client.h facts.h errors.h
	./libcompile client_xfer_command.c

client_xfer_compat.lo client_xfer_compat.o: libcompile client_xfer_compat.c v1client.h facts.h errors.h
	./libcompile client_xfer_compat.c

client_xfer_local.lo client_xfer_local.o: libcompile client_xfer_local.c v1client.h facts.h errors.h protocol.h
	./libcompile client_xfer_local.c

client_xfer_udp.lo client_xfer_udp.o: libcompile client_xfer_udp.c v1client.h facts.h errors.h protocol.h
	./libcompile client_xfer_udp.c

compile: conf-cc conf-bgincs
	( bgincs=`head -n 1 conf-bgincs`; \
	  echo '#!/bin/sh'; \
	  echo 'source=$$1; shift'; \
	  echo 'base=`echo "$$source" | sed -e s:\\\\.c$$::`'; \
	  echo exec `head -n 1 conf-cc` -I. "-I'$${bgincs}'" '-o $${base}.o -c $$source $${1+"$$@"}'; \
	) >compile
	chmod 755 compile

crypt.lib: compile load
	@echo -n 'Checking for -lcrypt: '
	@echo 'main() { ; }' >trylib-lcrypt.c
	@{ ./compile trylib-lcrypt.c && ./load trylib-lcrypt -lcrypt; } >/dev/null 2>&1 \
	  && { echo -lcrypt >crypt.lib; echo yes; } \
	  || { echo -n >crypt.lib; echo no; }
	@rm -f trylib-lcrypt.c trylib-lcrypt.o trylib-lcrypt

cvm-benchclient: cvm-benchclient.o ltload libcvm-v2client.la socket.lib
	./ltload cvm-benchclient libcvm-v2client.la -lbg `cat socket.lib`

cvm-benchclient.o: compile cvm-benchclient.c v2client.h facts.h errors.h
	./compile cvm-benchclient.c

cvm-chain: cvm-chain.o ltload libcvm-module.la libcvm-v2client.la socket.lib s.lib
	./ltload cvm-chain libcvm-module.la libcvm-v2client.la -lbg `cat socket.lib` `cat s.lib`

cvm-chain.o: compile cvm-chain.c module.h credentials.h errors.h facts.h v2client.h
	./compile cvm-chain.c

cvm-checkpassword: cvm-checkpassword.o ltload libcvm-v2client.la socket.lib
	./ltload cvm-checkpassword libcvm-v2client.la -lbg `cat socket.lib`

cvm-checkpassword.o: compile cvm-checkpassword.c v2client.h facts.h errors.h
	./compile cvm-checkpassword.c

cvm-mysql: cvm-mysql.o ltload libcvm-module.la libcvm-sql.la crypt.lib
	./ltload cvm-mysql libcvm-module.la libcvm-sql.la -lbg -lpwcmp -L/usr/lib/mysql -lmysqlclient `cat crypt.lib`

cvm-mysql-local: cvm-mysql-local.o ltload cvm-mysql.o libcvm-local.la libcvm-sql.la crypt.lib
	./ltload cvm-mysql-local cvm-mysql.o libcvm-local.la libcvm-sql.la -lbg -lpwcmp -L/usr/lib/mysql -lmysqlclient `cat crypt.lib`

cvm-mysql-local.o: compile cvm-mysql-local.c
	./compile cvm-mysql-local.c

cvm-mysql-udp: cvm-mysql-udp.o ltload cvm-mysql.o libcvm-udp.la libcvm-sql.la crypt.lib
	./ltload cvm-mysql-udp cvm-mysql.o libcvm-udp.la libcvm-sql.la -lbg -lpwcmp -L/usr/lib/mysql -lmysqlclient `cat crypt.lib`

cvm-mysql-udp.o: compile cvm-mysql-udp.c
	./compile cvm-mysql-udp.c

cvm-mysql.o: compile cvm-mysql.c module.h credentials.h errors.h facts.h sql.h
	./compile cvm-mysql.c

cvm-pgsql: cvm-pgsql.o ltload libcvm-module.la libcvm-sql.la crypt.lib
	./ltload cvm-pgsql libcvm-module.la libcvm-sql.la -lbg -lpwcmp -lpq `cat crypt.lib`

cvm-pgsql-local: cvm-pgsql-local.o ltload cvm-pgsql.o libcvm-local.la libcvm-sql.la crypt.lib
	./ltload cvm-pgsql-local cvm-pgsql.o libcvm-local.la libcvm-sql.la -lbg -lpwcmp -lpq `cat crypt.lib`

cvm-pgsql-local.o: compile cvm-pgsql-local.c
	./compile cvm-pgsql-local.c

cvm-pgsql-udp: cvm-pgsql-udp.o ltload cvm-pgsql.o libcvm-udp.la libcvm-sql.la crypt.lib
	./ltload cvm-pgsql-udp cvm-pgsql.o libcvm-udp.la libcvm-sql.la -lbg -lpwcmp -lpq `cat crypt.lib`

cvm-pgsql-udp.o: compile cvm-pgsql-udp.c
	./compile cvm-pgsql-udp.c

cvm-pgsql.o: compile cvm-pgsql.c module.h credentials.h errors.h facts.h sql.h
	./compile cvm-pgsql.c

cvm-pwfile: cvm-pwfile.o ltload libcvm-module.la crypt.lib socket.lib
	./ltload cvm-pwfile libcvm-module.la -lbg -lpwcmp `cat crypt.lib` `cat socket.lib`

cvm-pwfile.o: compile cvm-pwfile.c module.h credentials.h errors.h facts.h
	./compile cvm-pwfile.c

cvm-qmail: cvm-qmail.o ltload getpwnam.o libcvm-module.la libcvm-qmail.la crypt.lib
	./ltload cvm-qmail getpwnam.o libcvm-module.la libcvm-qmail.la -lbg `cat crypt.lib`

cvm-qmail.o: compile cvm-qmail.c module.h credentials.h errors.h facts.h qmail.h
	./compile cvm-qmail.c

cvm-testclient: cvm-testclient.o ltload libcvm-v2client.la socket.lib
	./ltload cvm-testclient libcvm-v2client.la -lbg `cat socket.lib`

cvm-testclient.o: compile cvm-testclient.c v2client.h facts.h errors.h
	./compile cvm-testclient.c

cvm-unix: cvm-unix.o ltload getpwnam.o libcvm-module.la crypt.lib shadow.lib s.lib socket.lib
	./ltload cvm-unix getpwnam.o libcvm-module.la -lbg `cat crypt.lib` `cat shadow.lib` `cat s.lib` `cat socket.lib`

cvm-unix.o: compile cvm-unix.c module.h credentials.h errors.h facts.h
	./compile cvm-unix.c

cvm-v1benchclient: cvm-v1benchclient.o ltload libcvm-v1client.la socket.lib
	./ltload cvm-v1benchclient libcvm-v1client.la -lbg `cat socket.lib`

cvm-v1benchclient.o: compile cvm-v1benchclient.c v1client.h facts.h errors.h
	./compile cvm-v1benchclient.c

cvm-v1checkpassword: cvm-v1checkpassword.o ltload libcvm-v1client.la socket.lib
	./ltload cvm-v1checkpassword libcvm-v1client.la -lbg `cat socket.lib`

cvm-v1checkpassword.o: compile cvm-v1checkpassword.c v1client.h facts.h errors.h
	./compile cvm-v1checkpassword.c

cvm-v1testclient: cvm-v1testclient.o ltload libcvm-v1client.la socket.lib
	./ltload cvm-v1testclient libcvm-v1client.la -lbg `cat socket.lib`

cvm-v1testclient.o: compile cvm-v1testclient.c v1client.h facts.h errors.h
	./compile cvm-v1testclient.c

cvm-vchkpw: cvm-vchkpw.o ltload libcvm-module.la crypt.lib shadow.lib s.lib socket.lib
	./ltload cvm-vchkpw libcvm-module.la -L/usr/local/vpopmail/lib -L/var/vpopmail/lib -L/usr/local/lib/mysql -lbg -lvpopmail -lmysqlclient `cat crypt.lib` `cat shadow.lib` `cat s.lib` `cat socket.lib`

cvm-vchkpw.o: compile cvm-vchkpw.c module.h credentials.h errors.h facts.h
	./compile cvm-vchkpw.c

cvm-vmailmgr: cvm-vmailmgr.o ltload vmautoconvert.o vmlookup.o getpwnam.o libcvm-module.la libcvm-qmail.la socket.lib crypt.lib
	./ltload cvm-vmailmgr vmautoconvert.o vmlookup.o getpwnam.o libcvm-module.la libcvm-qmail.la -lbg `cat socket.lib` `cat crypt.lib`

cvm-vmailmgr-local: cvm-vmailmgr-local.o ltload cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-local.la libcvm-qmail.la socket.lib crypt.lib
	./ltload cvm-vmailmgr-local cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-local.la libcvm-qmail.la -lbg `cat socket.lib` `cat crypt.lib`

cvm-vmailmgr-local.o: compile cvm-vmailmgr-local.c
	./compile cvm-vmailmgr-local.c

cvm-vmailmgr-udp: cvm-vmailmgr-udp.o ltload cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-udp.la libcvm-qmail.la socket.lib crypt.lib
	./ltload cvm-vmailmgr-udp cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-udp.la libcvm-qmail.la -lbg `cat socket.lib` `cat crypt.lib`

cvm-vmailmgr-udp.o: compile cvm-vmailmgr-udp.c
	./compile cvm-vmailmgr-udp.c

cvm-vmailmgr.o: compile cvm-vmailmgr.c module.h credentials.h errors.h facts.h qmail.h cvm-vmailmgr.h
	./compile cvm-vmailmgr.c

docs: 

errors.lo errors.o: libcompile errors.c errors.h
	./libcompile errors.c

facts.lo facts.o: libcompile facts.c facts.h
	./libcompile facts.c

getpwnam.o: compile getpwnam.c module.h credentials.h errors.h facts.h
	./compile getpwnam.c

install: INSTHIER conf-lib conf-bin conf-include
	bg-installer -v <INSTHIER
	bg-installer -c <INSTHIER

libcompile: conf-cc conf-bgincs
	( bgincs=`head -n 1 conf-bgincs`; \
	  if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
	  echo '#!/bin/sh'; \
	  echo 'source=$$1; shift'; \
	  echo 'base=`echo "$$source" | sed -e s:\\\\.c$$::`'; \
	  echo exec libtool --mode=compile --silent $$tag `head -n 1 conf-cc` -I. "-I'$${bgincs}'" '-o $${base}.lo -c $$source $${1+"$$@"}'; \
	) >libcompile
	chmod 755 libcompile

libcvm-command.la: makeshlib module_command.lo module_command_main.lo module_request.lo module_output.lo facts.lo
	./makeshlib libcvm-command.la module_command.lo module_command_main.lo module_request.lo module_output.lo facts.lo

libcvm-local.la: makeshlib module_local.lo module_local_main.lo module_request.lo module_output.lo module_log.lo facts.lo
	./makeshlib libcvm-local.la module_local.lo module_local_main.lo module_request.lo module_output.lo module_log.lo facts.lo

libcvm-module.la: makeshlib facts.lo module_command.lo module_local.lo module_log.lo module_main.lo module_output.lo module_request.lo module_udp.lo
	./makeshlib libcvm-module.la facts.lo module_command.lo module_local.lo module_log.lo module_main.lo module_output.lo module_request.lo module_udp.lo

libcvm-qmail.la: makeshlib qmail-domains.lo qmail-dotfile.lo qmail-init.lo qmail-lookup.lo qmail-users.lo
	./makeshlib libcvm-qmail.la qmail-domains.lo qmail-dotfile.lo qmail-init.lo qmail-lookup.lo qmail-users.lo

libcvm-sasl.la: makeshlib sasl_auth.lo sasl_authenticate.lo sasl_cram_md5.lo sasl_init.lo sasl_login.lo sasl_plain.lo sasl_start.lo
	./makeshlib libcvm-sasl.la sasl_auth.lo sasl_authenticate.lo sasl_cram_md5.lo sasl_init.lo sasl_login.lo sasl_plain.lo sasl_start.lo

libcvm-sql.la: makeshlib sql-auth.lo sql-query.lo
	./makeshlib libcvm-sql.la sql-auth.lo sql-query.lo

libcvm-udp.la: makeshlib module_udp.lo module_udp_main.lo module_request.lo module_output.lo module_log.lo facts.lo
	./makeshlib libcvm-udp.la module_udp.lo module_udp_main.lo module_request.lo module_output.lo module_log.lo facts.lo

libcvm-v1client.la: makeshlib v1client.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo
	./makeshlib libcvm-v1client.la v1client.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo

libcvm-v2client.la: makeshlib v2client.lo v2client_wrappers.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo random.lo
	./makeshlib libcvm-v2client.la v2client.lo v2client_wrappers.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo random.lo

libraries: libcvm-udp.la libcvm-local.la libcvm-module.la libcvm-sql.la libcvm-qmail.la libcvm-v1client.la libcvm-sasl.la libcvm-command.la libcvm-v2client.la

load: conf-ld conf-bglibs
	( bglibs=`head -n 1 conf-bglibs`; \
	  echo '#!/bin/sh';\
	  echo 'main="$$1"; shift';\
	  echo exec `head -n 1 conf-ld` -L. "-L'$${bglibs}'" "-Wl,-R'$${bglibs}'" '-o "$$main" "$$main.o" $${1+"$$@"}' -lbg-sysdeps; \
	) >load
	chmod 755 load

ltload: conf-ld conf-bglibs
	( bglibs=`head -n 1 conf-bglibs`; \
	  if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
	  echo '#!/bin/sh';\
	  echo 'main="$$1"; shift';\
	  echo exec libtool --mode=link --silent $$tag `head -n 1 conf-ld` -L. "-L'$${bglibs}'" "-Wl,-R'$${bglibs}'" '-o "$$main" "$$main.o" $${1+"$$@"}' -lbg-sysdeps; \
	) >ltload
	chmod 755 ltload

makeshlib: conf-ld conf-lib LIBVERSION Makefile
	( if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
	  echo '#!/bin/sh'; \
	  echo 'lib="$$1"; shift';\
	  echo 'rm -f "$$lib"';\

## cvm 0.96

=== Makefile ===
--- 
+++ 
@@ -14,26 +14,26 @@
 clean-spac: clean AUTOFILES
 	rm -f `cat AUTOFILES`
 
-client_domain.lo client_domain.o: libcompile client_domain.c v1client.h facts.h errors.h
-	./libcompile client_domain.c
-
-client_setenv.lo client_setenv.o: libcompile client_setenv.c v1client.h facts.h errors.h
-	./libcompile client_setenv.c
-
-client_setugid.lo client_setugid.o: libcompile client_setugid.c v1client.h facts.h errors.h
-	./libcompile client_setugid.c
-
-client_xfer_command.lo client_xfer_command.o: libcompile client_xfer_command.c v1client.h facts.h errors.h
-	./libcompile client_xfer_command.c
-
-client_xfer_compat.lo client_xfer_compat.o: libcompile client_xfer_compat.c v1client.h facts.h errors.h
-	./libcompile client_xfer_compat.c
-
-client_xfer_local.lo client_xfer_local.o: libcompile client_xfer_local.c v1client.h facts.h errors.h protocol.h
-	./libcompile client_xfer_local.c
-
-client_xfer_udp.lo client_xfer_udp.o: libcompile client_xfer_udp.c v1client.h facts.h errors.h protocol.h
-	./libcompile client_xfer_udp.c
+client_domain.lo client_domain.o: ltcompile client_domain.c v1client.h facts.h errors.h
+	./ltcompile client_domain.c
+
+client_setenv.lo client_setenv.o: ltcompile client_setenv.c v1client.h facts.h errors.h
+	./ltcompile client_setenv.c
+
+client_setugid.lo client_setugid.o: ltcompile client_setugid.c v1client.h facts.h errors.h
+	./ltcompile client_setugid.c
+
+client_xfer_command.lo client_xfer_command.o: ltcompile client_xfer_command.c v1client.h facts.h errors.h
+	./ltcompile client_xfer_command.c
+
+client_xfer_compat.lo client_xfer_compat.o: ltcompile client_xfer_compat.c v1client.h facts.h errors.h
+	./ltcompile client_xfer_compat.c
+
+client_xfer_local.lo client_xfer_local.o: ltcompile client_xfer_local.c v1client.h facts.h errors.h protocol.h
+	./ltcompile client_xfer_local.c
+
+client_xfer_udp.lo client_xfer_udp.o: ltcompile client_xfer_udp.c v1client.h facts.h errors.h protocol.h
+	./ltcompile client_xfer_udp.c
 
 compile: conf-cc conf-bgincs
 	( bgincs=`head -n 1 conf-bgincs`; \
@@ -118,6 +118,12 @@
 cvm-qmail.o: compile cvm-qmail.c module.h credentials.h errors.h facts.h qmail.h
 	./compile cvm-qmail.c
 
+cvm-sqlite: cvm-sqlite.o ltload libcvm-module.la libcvm-sql.la crypt.lib
+	./ltload cvm-sqlite libcvm-module.la libcvm-sql.la -lbg -lpwcmp -L/usr/lib/sqlite -lsqlite3 `cat crypt.lib`
+
+cvm-sqlite.o: compile cvm-sqlite.c cvm/module.h credentials.h errors.h facts.h sql.h
+	./compile cvm-sqlite.c
+
 cvm-testclient: cvm-testclient.o ltload libcvm-v2client.la socket.lib
 	./ltload cvm-testclient libcvm-v2client.la -lbg `cat socket.lib`
 
@@ -174,11 +180,11 @@
 
 docs: 
 
-errors.lo errors.o: libcompile errors.c errors.h
-	./libcompile errors.c
-
-facts.lo facts.o: libcompile facts.c facts.h
-	./libcompile facts.c
+errors.lo errors.o: ltcompile errors.c errors.h
+	./ltcompile errors.c
+
+facts.lo facts.o: ltcompile facts.c facts.h
+	./ltcompile facts.c
 
 getpwnam.o: compile getpwnam.c module.h credentials.h errors.h facts.h
 	./compile getpwnam.c
@@ -187,16 +193,6 @@
 	bg-installer -v <INSTHIER
 	bg-installer -c <INSTHIER
 
-libcompile: conf-cc conf-bgincs
-	( bgincs=`head -n 1 conf-bgincs`; \
-	  if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
-	  echo '#!/bin/sh'; \
-	  echo 'source=$$1; shift'; \
-	  echo 'base=`echo "$$source" | sed -e s:\\\\.c$$::`'; \
-	  echo exec libtool --mode=compile --silent $$tag `head -n 1 conf-cc` -I. "-I'$${bgincs}'" '-o $${base}.lo -c $$source $${1+"$$@"}'; \
-	) >libcompile
-	chmod 755 libcompile
-
 libcvm-command.la: makeshlib module_command.lo module_command_main.lo module_request.lo module_output.lo facts.lo
 	./makeshlib libcvm-command.la module_command.lo module_command_main.lo module_request.lo module_output.lo facts.lo
 
@@ -224,7 +220,7 @@
 libcvm-v2client.la: makeshlib v2client.lo v2client_wrappers.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo random.lo
 	./makeshlib libcvm-v2client.la v2client.lo v2client_wrappers.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo random.lo
 
-libraries: libcvm-udp.la libcvm-local.la libcvm-module.la libcvm-sql.la libcvm-qmail.la libcvm-v1client.la libcvm-sasl.la libcvm-command.la libcvm-v2client.la
+libraries: libcvm-sasl.la libcvm-local.la libcvm-sql.la libcvm-v1client.la libcvm-udp.la libcvm-v2client.la libcvm-module.la libcvm-command.la libcvm-qmail.la
 
 load: conf-ld conf-bglibs
 	( bglibs=`head -n 1 conf-bglibs`; \
@@ -233,6 +229,16 @@
 	  echo exec `head -n 1 conf-ld` -L. "-L'$${bglibs}'" "-Wl,-R'$${bglibs}'" '-o "$$main" "$$main.o" $${1+"$$@"}' -lbg-sysdeps; \
 	) >load
 	chmod 755 load
+
+ltcompile: conf-cc conf-bgincs
+	( bgincs=`head -n 1 conf-bgincs`; \
+	  if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
+	  echo '#!/bin/sh'; \
+	  echo 'source=$$1; shift'; \
+	  echo 'base=`echo "$$source" | sed -e s:\\\\.c$$::`'; \
+	  echo exec libtool --mode=compile --silent $$tag `head -n 1 conf-cc` -I. "-I'$${bgincs}'" '-o $${base}.lo -c $$source $${1+"$$@"}'; \
+	) >ltcompile
+	chmod 755 ltcompile
 
 ltload: conf-ld conf-bglibs
 	( bglibs=`head -n 1 conf-bglibs`; \
@@ -243,8 +249,3 @@
 	) >ltload
 	chmod 755 ltload
 
-makeshlib: conf-ld conf-lib LIBVERSION Makefile
-	( if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
-	  echo '#!/bin/sh'; \
-	  echo 'lib="$$1"; shift';\
-	  echo 'rm -f "$$lib"';\

## cvm 0.97

=== Makefile ===
--- 
+++ 
@@ -35,12 +35,11 @@
 client_xfer_udp.lo client_xfer_udp.o: ltcompile client_xfer_udp.c v1client.h facts.h errors.h protocol.h
 	./ltcompile client_xfer_udp.c
 
-compile: conf-cc conf-bgincs
-	( bgincs=`head -n 1 conf-bgincs`; \
-	  echo '#!/bin/sh'; \
+compile: conf-cc
+	( echo '#!/bin/sh'; \
 	  echo 'source=$$1; shift'; \
 	  echo 'base=`echo "$$source" | sed -e s:\\\\.c$$::`'; \
-	  echo exec `head -n 1 conf-cc` -I. "-I'$${bgincs}'" '-o $${base}.o -c $$source $${1+"$$@"}'; \
+	  echo exec `head -n 1 conf-cc` -I.  '-o $${base}.o -c $$source $${1+"$$@"}'; \
 	) >compile
 	chmod 755 compile
 
@@ -121,7 +120,7 @@
 cvm-sqlite: cvm-sqlite.o ltload libcvm-module.la libcvm-sql.la crypt.lib
 	./ltload cvm-sqlite libcvm-module.la libcvm-sql.la -lbg -lpwcmp -L/usr/lib/sqlite -lsqlite3 `cat crypt.lib`
 
-cvm-sqlite.o: compile cvm-sqlite.c cvm/module.h credentials.h errors.h facts.h sql.h
+cvm-sqlite.o: compile cvm-sqlite.c module.h credentials.h errors.h facts.h sql.h
 	./compile cvm-sqlite.c
 
 cvm-testclient: cvm-testclient.o ltload libcvm-v2client.la socket.lib
@@ -161,16 +160,16 @@
 	./compile cvm-vchkpw.c
 
 cvm-vmailmgr: cvm-vmailmgr.o ltload vmautoconvert.o vmlookup.o getpwnam.o libcvm-module.la libcvm-qmail.la socket.lib crypt.lib
-	./ltload cvm-vmailmgr vmautoconvert.o vmlookup.o getpwnam.o libcvm-module.la libcvm-qmail.la -lbg `cat socket.lib` `cat crypt.lib`
+	./ltload cvm-vmailmgr vmautoconvert.o vmlookup.o getpwnam.o libcvm-module.la libcvm-qmail.la -lbg -lvmailmgr `cat socket.lib` `cat crypt.lib`
 
 cvm-vmailmgr-local: cvm-vmailmgr-local.o ltload cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-local.la libcvm-qmail.la socket.lib crypt.lib
-	./ltload cvm-vmailmgr-local cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-local.la libcvm-qmail.la -lbg `cat socket.lib` `cat crypt.lib`
+	./ltload cvm-vmailmgr-local cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-local.la libcvm-qmail.la -lbg -lvmailmgr `cat socket.lib` `cat crypt.lib`
 
 cvm-vmailmgr-local.o: compile cvm-vmailmgr-local.c
 	./compile cvm-vmailmgr-local.c
 
 cvm-vmailmgr-udp: cvm-vmailmgr-udp.o ltload cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-udp.la libcvm-qmail.la socket.lib crypt.lib
-	./ltload cvm-vmailmgr-udp cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-udp.la libcvm-qmail.la -lbg `cat socket.lib` `cat crypt.lib`
+	./ltload cvm-vmailmgr-udp cvm-vmailmgr.o vmautoconvert.o vmlookup.o getpwnam.o libcvm-udp.la libcvm-qmail.la -lbg -lvmailmgr `cat socket.lib` `cat crypt.lib`
 
 cvm-vmailmgr-udp.o: compile cvm-vmailmgr-udp.c
 	./compile cvm-vmailmgr-udp.c
@@ -220,32 +219,34 @@
 libcvm-v2client.la: makeshlib v2client.lo v2client_wrappers.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo random.lo
 	./makeshlib libcvm-v2client.la v2client.lo v2client_wrappers.lo client_domain.lo client_setugid.lo client_setenv.lo client_xfer_command.lo client_xfer_compat.lo client_xfer_local.lo client_xfer_udp.lo errors.lo facts.lo random.lo
 
-libraries: libcvm-sasl.la libcvm-local.la libcvm-sql.la libcvm-v1client.la libcvm-udp.la libcvm-v2client.la libcvm-module.la libcvm-command.la libcvm-qmail.la
-
-load: conf-ld conf-bglibs
-	( bglibs=`head -n 1 conf-bglibs`; \
-	  echo '#!/bin/sh';\
+libraries: libcvm-module.la libcvm-v2client.la libcvm-local.la libcvm-command.la libcvm-v1client.la libcvm-udp.la libcvm-sql.la libcvm-sasl.la libcvm-qmail.la
+
+load: conf-ld
+	( echo '#!/bin/sh';\
 	  echo 'main="$$1"; shift';\
-	  echo exec `head -n 1 conf-ld` -L. "-L'$${bglibs}'" "-Wl,-R'$${bglibs}'" '-o "$$main" "$$main.o" $${1+"$$@"}' -lbg-sysdeps; \
+	  echo exec `head -n 1 conf-ld` -L. '-o "$$main" "$$main.o" $${1+"$$@"}'; \
 	) >load
 	chmod 755 load
 
-ltcompile: conf-cc conf-bgincs
-	( bgincs=`head -n 1 conf-bgincs`; \
-	  if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
+ltcompile: conf-cc
+	( if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
 	  echo '#!/bin/sh'; \
 	  echo 'source=$$1; shift'; \
 	  echo 'base=`echo "$$source" | sed -e s:\\\\.c$$::`'; \
-	  echo exec libtool --mode=compile --silent $$tag `head -n 1 conf-cc` -I. "-I'$${bgincs}'" '-o $${base}.lo -c $$source $${1+"$$@"}'; \
+	  echo exec libtool --mode=compile --silent $$tag `head -n 1 conf-cc` -I.  '-o $${base}.lo -c $$source $${1+"$$@"}'; \
 	) >ltcompile
 	chmod 755 ltcompile
 
-ltload: conf-ld conf-bglibs
-	( bglibs=`head -n 1 conf-bglibs`; \
-	  if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
+ltload: conf-ld
+	( if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
 	  echo '#!/bin/sh';\
 	  echo 'main="$$1"; shift';\
-	  echo exec libtool --mode=link --silent $$tag `head -n 1 conf-ld` -L. "-L'$${bglibs}'" "-Wl,-R'$${bglibs}'" '-o "$$main" "$$main.o" $${1+"$$@"}' -lbg-sysdeps; \
+	  echo exec libtool --mode=link --silent $$tag `head -n 1 conf-ld` -L. '-o "$$main" "$$main.o" $${1+"$$@"}' ; \
 	) >ltload
 	chmod 755 ltload
 
+makeshlib: conf-ld conf-lib LIBVERSION Makefile
+	( if libtool --tag=CC --help >/dev/null 2>&1; then tag='--tag=CC'; fi; \
+	  echo '#!/bin/sh'; \
+	  echo 'lib="$$1"; shift';\
+	  echo 'rm -f "$$lib"';\

=== debian/changelog ===
cvm (0.97-4) unstable; urgency=medium

  * QA upload.
  * Fix return value for main(). Closes: #1074896.
  * Add libcrypt-dev to Build-Depends. Closes: #1107011.
  * Build using C17 standard with GNU extensions.
  * Update standards-version.

 -- Santiago Vila <sanvila@debian.org>  Fri, 29 Aug 2025 20:30:00 +0200

cvm (0.97-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061994

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Feb 2024 23:24:25 +0000

cvm (0.97-3) unstable; urgency=medium

  * QA upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libbg-dev.

 -- Jelmer Vernooĳ <jelmer@debian.org>  Fri, 27 May 2022 20:24:32 +0100

cvm (0.97-2) unstable; urgency=medium

  * QA upload.
  * Use group targets in sql-query.{o,lo} rule to fix parallel build

 -- Baptiste BEAUPLAT <lyknode@cilg.org>  Thu, 27 Aug 2020 18:16:24 +0200

cvm (0.97-1) unstable; urgency=medium

  * QA upload.
  * d/control:
    + Set QA Group as Maintainer (Orphan bug: #947695)
    + Move homepage from description to its own field
    + Use https version of the Homepage
    + Use Rules-Requires-Root: no
    + Bump Standard-Version to 4.5.0
    + Add Vcs-Browser and Vcs-Git, pointing to salsa project
    + Set debhelper-compat to 13
    + Add missing ${misc:Depends} dependency to binary packages
    + Remove redundant Section field for some binary packages
    + Remove unused build dependencies: vim, sqlite3, libsqlite3-dev
    + Add a short text to long description to differentiate binary packages
    + Add missing dependency xxd required to run tests
  * Migrate to dh: (Closes: #848588)
    + Remove rules.orig
    + Drop d/implicit
    + Replace d/rules by a dh compatible rules
    + Override dh_auto_build to build 3 specific targets (all, mysql, pgsql)
      and inject correct FLAGS for building and linking (via conf-* files).
    + Override dh_auto_clean to cleanup generated conf-* files
    + Override dh_auto_install to force install tool to work with DESTDIR
    + Override dh_auto_test to run ./tests.sh
    + Add .install files for binary package
    + Exclude *.la files in d/not-installed
    + Remove unused post{inst,rm}
    + Use hardening=+all flags
  * Replace upstream signing key by its minimal version
  * Convert copyright to DEP5
  * Move all manpages to d/manpages
  * Add ${pkg}.manpages for cvm, cvm-mysql and cvm-pgsql
  * Use recommended branch name from DEP14
  * Add salsa pipeline CI
  * Register development docs with doc-base
  * Add patch to exclude sqlite test case from tests.sh as sqlite cvm tools
    are not built in Debian packaging
  * Fix typo in package name in d/cvm.README.Debian
  * Use better url source for d/watch
  * Skip tests/qmail-lookup-perms and tests/vmlookup-notable tests when run as
    root
  * Override package-name-doesnt-match-sonames for libcvm1

 -- Baptiste BEAUPLAT <lyknode@cilg.org>  Fri, 21 Aug 2020 21:43:30 +0200

cvm (0.97-0.1) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Make build reproducible (Closes: #813944)
    - thanks Reiner for the patch

  [ Dmitry Bogatov ]
  * Non-maintainer upload.
  * New upstream release (compatible with bglibs >= 2.03)
  * Write watch file and verify GPG signature
  * Upgrade dependendency on bglibs (libbg1-dev -> libbg-dev >= 2.03)
  * Drop rpath related patch (fixed upstream)
  * Adjust debian/rules to changed upstream Makefile
  * Add ldconfig trigger

 -- Dmitry Bogatov <KAction@gnu.org>  Fri, 17 Feb 2017 12:42:51 +0300

cvm (0.96-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Update Build-Depends from libmysqlclient-dev to
    default-libmysqlclient-dev. (Closes: #845832)

 -- Christian Hofstaedtler <zeha@debian.org>  Sun, 18 Dec 2016 17:07:58 +0000

cvm (0.96-1.2) unstable; urgency=medium

  * Non-maintainer upload on request of the maintainer.
  * Update build-depends to libmysqlclient-dev; thanks to Clint Byrum.
    Closes: #650426
  * Add "Section" header to debian/control; thanks to Stefano Rivera.
    Closes: #582283
  * Update padding in tests.sh so tests/vmailmgr-xconvert doesn't fail.

 -- Martin Michlmayr <tbm@cyrius.com>  Wed, 01 Jul 2015 16:02:36 +0400

cvm (0.96-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Build-depend on libtool-bin. Closes: #761742.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Oct 2014 10:20:24 +0000

cvm (0.96-1) unstable; urgency=low

  * new upstream version.
  * debian/diff/0001-tests.sh-fix-variables-in-selftests.diff: remove;
    fixed upstream.
  * debian/rules: workaround non-working variable assignment with dash
    as sh.
  * debian/control: Build-Depends: libsqlite3-dev, sqlite3.
  * debian/rules: build the new cvm-sqlite.
  * debian/diff/0001-Makefile-avoid-rpath-workaround-some-...diff:
    adapt for cvm-sqlite.
  * debian/rules: don't install cvm-sqlite for now.

 -- Gerrit Pape <pape@smarden.org>  Thu, 15 Apr 2010 02:27:30 +0000

cvm (0.90-1) unstable; urgency=low

  * new upstream version.
  * debian/rules: mostly redo; build, install new packages; drop diet
    libraries for now.
  * debian/control: change binary package cvm-dev to libcvm1-dev,
    lib-cvm1, providing shared and static libraries; no longer
    Build-Depends: dietlibc-dev; Build-Depends: libbg1-dev, libtool
    Standards-Version: 3.7.3.0.
  * debian/cvm-*.[78]: add description to NAME.
  * debian/diff/0001-tests.sh-fix-variables-in-selftests.diff: new;
    redo tests.diff with git.
  * debian/diff/0002-Makefile-avoid-rpath-workaround-some...diff: new;
    Makefile: avoid rpath; workaround some linking issues.
  * README.Debian.diet, debian/cvm.docs: remove; drop for now.
  * debian/cvm-dev.README.Debian, debian/cvm-dev.docs: rename to
    libcvm1-dev.* respectively.
  * debian/libcvm1-dev.docs: adapt paths.
  * libcvm1.postinst, libcvm1.postrm: new; run ldconfig on configure,
    remove.


=== debian/control ===
Source: cvm
Section: admin
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
 libbg-dev,
 default-libmysqlclient-dev,
 libcrypt-dev,
 libpq-dev,
 libtool,
 libtool-bin,
 freecdb,
 xxd
Standards-Version: 4.7.2
Homepage: https://untroubled.org/cvm/cvm.html
Vcs-Browser: https://salsa.debian.org/debian/cvm
Vcs-Git: https://salsa.debian.org/debian/cvm.git
Rules-Requires-Root: no

Package: cvm
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Credential Validation Modules
 CVM is a framework for validating a set of credentials against a database
 using a filter program.  The modules act as a filter, taking a set of
 credentials as input and writing a set of facts as output if those
 credentials are valid.  Optional input is given to the module through
 environment variables.
 .
 Some of the ideas for CVM came from experience with PAM (pluggable
 authentication modules), the checkpassword interface used by qmail-pop3d,
 and the "authmod" interface used by Courier IMAP and POP3.  This framework
 places fewer restrictions on the invoking client than checkpassword does,
 and is much simpler to implement on both sides than PAM and the authmod
 framework.
 .
 This package includes cvm binaries.

Package: cvm-mysql
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: cvm
Description: Credential Validation Modules (MySQL)
 CVM is a framework for validating a set of credentials against a database
 using a filter program.  The modules act as a filter, taking a set of
 credentials as input and writing a set of facts as output if those
 credentials are valid.  Optional input is given to the module through
 environment variables.
 .
 Some of the ideas for CVM came from experience with PAM (pluggable
 authentication modules), the checkpassword interface used by qmail-pop3d,
 and the "authmod" interface used by Courier IMAP and POP3.  This framework
 places fewer restrictions on the invoking client than checkpassword does,
 and is much simpler to implement on both sides than PAM and the authmod
 framework.
 .
 This package includes cvm binaries to interact with MySQL databases.

Package: cvm-pgsql
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: cvm
Description: Credential Validation Modules (PostgreSQL)
 CVM is a framework for validating a set of credentials against a database
 using a filter program.  The modules act as a filter, taking a set of
 credentials as input and writing a set of facts as output if those
 credentials are valid.  Optional input is given to the module through
 environment variables.
 .
 Some of the ideas for CVM came from experience with PAM (pluggable
 authentication modules), the checkpassword interface used by qmail-pop3d,
 and the "authmod" interface used by Courier IMAP and POP3.  This framework
 places fewer restrictions on the invoking client than checkpassword does,
 and is much simpler to implement on both sides than PAM and the authmod
 framework.
 .
 This package includes cvm binaries to interact with PostgreSQL databases.

Package: libcvm1t64
Provides: ${t64:Provides}
Replaces: libcvm1
Breaks: libcvm1 (<< ${source:Version})
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libcvm1-dev
Description: Credential Validation Modules (shared libraries)
 CVM is a framework for validating a set of credentials against a database
 using a filter program.  The modules act as a filter, taking a set of
 credentials as input and writing a set of facts as output if those
 credentials are valid.  Optional input is given to the module through
 environment variables.
 .
 Some of the ideas for CVM came from experience with PAM (pluggable
 authentication modules), the checkpassword interface used by qmail-pop3d,
 and the "authmod" interface used by Courier IMAP and POP3.  This framework
 places fewer restrictions on the invoking client than checkpassword does,
 and is much simpler to implement on both sides than PAM and the authmod
 framework.
 .
 This package includes shared libraries required to run dependent binaries.

Package: libcvm1-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libcvm1t64 (= ${binary:Version})
Provides: libcvm-dev, cvm-dev
Conflicts: libcvm-dev, cvm-dev
Recommends: cvm
Description: Credential Validation Modules (development files, documentation)
 CVM is a framework for validating a set of credentials against a database
 using a filter program.  The modules act as a filter, taking a set of
 credentials as input and writing a set of facts as output if those
 credentials are valid.  Optional input is given to the module through
 environment variables.
 .
 Some of the ideas for CVM came from experience with PAM (pluggable
 authentication modules), the checkpassword interface used by qmail-pop3d,
 and the "authmod" interface used by Courier IMAP and POP3.  This framework
 places fewer restrictions on the invoking client than checkpassword does,
 and is much simpler to implement on both sides than PAM and the authmod
 framework.
 .
 This package includes development files for compiling against libcvm1t64

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -I$(shell pg_config --includedir) -Wall \
	-pedantic -std=gnu17

%:
	dh $@

override_dh_auto_build:
	# Makefile uses files instead of environment variable for...
	# ..compiler command and flags
	test -e conf-cc.orig || cp conf-cc conf-cc.orig
	echo '$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)' > conf-cc

	# ..linker command and flags
	test -e conf-ld.orig || cp conf-ld conf-ld.orig
	echo '$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)' > conf-ld

	# ...prefix install path
	test -e conf-bin.orig || cp conf-bin conf-bin.orig
	echo '/usr/bin' > conf-bin

	test -e conf-include.orig || cp conf-include conf-include.orig
	echo '/usr/include' > conf-include

	test -e conf-lib.orig || cp conf-lib conf-lib.orig
	echo '/usr/lib' > conf-lib

	# Finally, make target all, mysql and pgsql
	dh_auto_build
	dh_auto_build -- mysql
	dh_auto_build -- pgsql

override_dh_auto_test:
	sh ./tests.sh

# bg-installer is ignoring DESTDIR, using program-specific install_prefix
override_dh_auto_install:
	dh_auto_install -- install_prefix=$(CURDIR)/debian/tmp

# Cleanup conf files
override_dh_auto_clean:
	dh_auto_clean

	# Revert Makefile configuration
	for file in conf-cc conf-bin conf-include conf-lib; do \
	    test ! -r $$file.orig || mv -f $$file.orig $$file || exit 1; \
	done

	# Cleanup leftovers
	rm -rf .libs

=== debian/watch ===
version=4
# Note: in july 2020, https doesn't work due to weak TLS server options
opts="pgpmode=auto" \
http://untroubled.org/cvm/archive/cvm-@ANY_VERSION@@ARCHIVE_EXT@
